/*
Scrivere un programma che utilizzi la procedura qsort e ordini un vettore
di interi non negativi (in input), in modo da ottenere il seguente effetto.
L'array riordinato deve contenere prima tutti i numeri pari e, a seguire, i
numeri dispari. I numeri pari devono essere ordinati in modo crescente fra di
loro. I numeri dispari devono essere ordinati in modo decrescente fra di loro.
La sequenza in input è, come al solito, il numero N (non limitato) di interi
seguiti da N valori interi non negativi. Stampare la sequenza riordinata in
output su una sola riga. Nota: il numero zero è, per convenzione, ritenuto
sempre pari.
*/
#include <stdio.h>
#include <stdlib.h>


int paridispari(const void *p1, const void *p2){
	/*
	a e b contengono i VALORI che sto confrontando
	Infatti il qsort in questo caso opera su int*
	e con una operazione di dereferenziazione
	possiamo ottenere il valore degli elementi 
	che stiamo confrontando
	*/
	int a = * (int*)p1;
	int b = * (int*)p2;
	
	//sono entrambi pari
	if (a%2==0 && b%2==0)
		return a-b;
	//sono entrambi dispari
	else if (a%2==1 && b%2==1)
		return b-a;
	//a è dispari e b è pari
	else if (a%2==1 && b%2==0)
		return 1;
	//a è pari e b è dispari
	else return -1;
}


int main() {

	int n, *A;
	
	//leggo da input l'array
	scanf("%d", &n);
	A = (int*)malloc(n*sizeof(int));
	int i;
	for (i=0; i<n; i++) 
		scanf("%d", A+i);

	//eseguo l'ordinamento
	qsort(A, n, sizeof(int), paridispari);

	printf("\n");
	for(i=0; i<n; i++)
		printf("%d\n", A[i]);
	return 0;
}
