/*
Scrivere un programma che legga da tastiera un array A di stringhe e che
utilizzi la funzione di libreria qsort per ordinare in ordine alfabetico crescente
le stringhe in input. Stampare in outupt la sequenza di stringhe ordinata,
una per riga. L'input è formattato nel seguente modo: sulla prima riga
si trova il numero N di stringhe. Seguono N righe contenenti ognuna una
una stringa dell'insieme da ordinare. Le stringhe contengono soltanto carat-
teri alfanumerici (a-z minuscoli e maiuscoli o numeri, nessuno spazio o
punteggiatura) e sono lunghe al più 1000 caratteri ciascuna.
*/

#include <stdio.h>
#include <stdlib.h>
#define MAX_LEN 1000

int comparatore(const void *p1, const void *p2){
	/* 
	I due parametri sono dei puntatori ai valori dell'array,
	ovvero 2 puntatori a stringhe: char **. Prima li 
	"interpretiamo" con un cast a puntatori a stringhe,
	poi li dereferenziamo per ottenere l'effettiva stringa. 
	*/
	char *stringa1 = *(char **)p1;
	char *stringa2 = *(char **)p2;
	int i;

	/*
	Confronto alfabetico tra due stringhe. 
	Se una stringa e' prefisso dell'altra, essa e' minore.
	Supponendo non siano ne' identiche ne' prefisso, 
	allora il primo carattere discordante determina l'ordinamento.
	La procedura sotto è equivalente ad una chiamata alla funzione
	strcmp(stringa1, stringa2); definita in string.h
	*/
	for (i=0;
		stringa1[i] == stringa2[i] && stringa1[i] != '\0'; 
		i++);

	if ( stringa1[i] < stringa2[i] ) 
		return -1;
	else if ( stringa1[i] == stringa2[i] /* == '\0' */)   
		return 0;
	else return 1;
}


int main() {

	int n;
	char **A;
	
	//leggo da input l'array
	scanf("%d", &n);
	A = (char**)malloc(n*sizeof(char*));
	if (A == NULL) return 1;

	int i;
	for (i=0; i<n; i++){
		A[i] = (char*)malloc(MAX_LEN*sizeof(char));
		if (A[i] == NULL) return 1;
		scanf("%s", A[i]);
	}

	//eseguo l'ordinamento
	qsort(A, n, sizeof(char*), comparatore);

	printf("\n");
	for(i=0; i<n; i++)
		printf("%s\n", A[i]);
	return 0;
}
